dojo.provide("net.jazz.example.workitem.web.ui.LinkedDefectEditorToolbarAction"); //$NON-NLS-1$

dojo.require("com.ibm.team.workitem.web.ui2.internal.action.AbstractAction"); //$NON-NLS-1$

dojo.require("com.ibm.team.workitem.web.client.util"); //$NON-NLS-1$

(function() {
	
	// WorkItem Types list of entities that for which the actions apply
	
	var workItemEnabledType = "com.ibm.team.apt.workItemType.story";
	
	// Link Type to use
	
	var linkType = "com.ibm.team.workitem.linktype.parentworkitem";
	
	// WorkItem Type to generate
	
	var workItem2Gen = "defect";
	
	var WorkItemUtil = com.ibm.team.workitem.web.client.util;
	
	dojo.declare("net.jazz.example.workitem.web.ui.LinkedDefectEditorToolbarAction", com.ibm.team.workitem.web.ui2.internal.action.AbstractAction,
 	{
		constructor: function(){
		
			// Calculate current Project Area and Work Item Type
		
			this._currentWIType = new String(this.workingCopy.getValue({ path: "attributes.workItemType.id"}));
			this._currentPArea = new String(this.workingCopy.getValue({ path: "attributes.projectArea.id"}));
		
		},
		
		run: function(parms) {
			
			// Generate the required arguments object
			
			var args = {
					
					newWorkItemProjectAreaItemId: this._currentPArea,
					typeName: workItem2Gen,
					addLinkIsSource: false,
					addLinkType: linkType,
					addLinkedProjectAreaItemId: this._currentPArea,
					addLinkedItemId: this.workingCopy.getItemId()
				
				}
			
			// Get the draft resource url
			
			var url = WorkItemUtil.getNewWorkItemUri2(args);
			
			// Redirect to the generated resource
			
			window.location = url;
			
		},
	
		isEnabled: function()
		{
			
			// Our action is to be only enabled in the Story Work Item and when no change in "on-fly" 
			
			return !this.workingCopy.isNew() && !this.workingCopy.isChanged() && (this._currentWIType==workItemEnabledType);
			
		},
		
		isVisible: function(parms) {
		
			// The action is visible just in Story Work Item
			
			return this._currentWIType==workItemEnabledType;
			
		}
		
	});

})();